#ifndef  __IP_INIT_H
#define  __IP_INIT_H

#define  BUZZER_ON()               (PD->DOUT |=  0x0200)
#define  BUZZER_OFF()              (PD->DOUT &= ~0x0200)
#define  LED_R_ON()                (PB->DOUT &= ~0x8000)
#define  LED_R_OFF()               (PB->DOUT |=  0x8000)
#define  LED_R_TOGGLE()            (PB->DOUT ^=  0x8000) 
#define  LED_G_ON()                (PA->DOUT &= ~0x4000)
#define  LED_G_OFF()               (PA->DOUT |=  0x4000)
#define  LED_G_TOGGLE()            (PA->DOUT ^=  0x4000)
#define  LED_B_ON()                (PD->DOUT &= ~0x0400)
#define  LED_B_OFF()               (PD->DOUT |=  0x0400)
#define  LED_B_TOGGLE()            (PD->DOUT ^=  0x0400)

#ifdef  IP_INIT_GLOBAL
#define IP_EXT
#else
#define IP_EXT extern
#endif

typedef struct{
  volatile   uint8_t  *pTx ;
  volatile   uint8_t  *pRx ;
  volatile   uint32_t NumTx ;
  volatile   uint32_t NumRx ;
}STRUCT_SIO_DATA ;
IP_EXT  STRUCT_SIO_DATA  SPI1_Data ;
IP_EXT  STRUCT_SIO_DATA  COM0_Data ;
IP_EXT  STRUCT_SIO_DATA  COM1_Data ;
IP_EXT  STRUCT_SIO_DATA  I2C_Buf ;

IP_EXT uint32_t volatile  Event ;                          // ע
#define  Event_T1_INT              (0x0001ul)
#define  Event_T1_INT_5           (0x0002ul)             
#define  Event_UART0_Rx            (0x0004ul)             
#define  Event_UART1_Rx            (0x0008ul)

IP_EXT uint32_t volatile  gFlag ;                          // ־λ
#define  F_I2C_ERR                 0x0001

extern uint16_t TabLCD[] ;
void SysClkInit(void) ;

void Timer1Init(void) ;
void Delayus(uint32_t Tim) ;
void LCD_Init(void) ;
void UART0_Init(uint32_t Baud) ;
void UART1_Init(uint32_t Baud) ;
void SPI1_Init(uint32_t Div) ;
void I2C1_Init(uint8_t Address) ;
void RTC_Init(void) ;
void ADC_Init(void) ;

#define CHECK_ON()                 (LCD->MEM_0 |=  0x00000001)   
#define CHECK_OFF()                (LCD->MEM_0 &= ~0x00000001)   
#define ACCUMULATE_ON()            (LCD->MEM_0 |=  0x00010000)   
#define ACCUMULATE_OFF()           (LCD->MEM_0 &= ~0x00010000)   
#define DATE_ON()                  (LCD->MEM_1 |=  0x00000001)   
#define DATE_OFF()                 (LCD->MEM_1 &= ~0x00000001)   
#define TIME_ON()                  (LCD->MEM_1 |=  0x00010000)   
#define TIME_OFF()                 (LCD->MEM_1 &= ~0x00010000)   

#define HOT_ON()                   (LCD->MEM_2 |=  0x00000001)   
#define HOT_OFF()                  (LCD->MEM_2 &= ~0x00000001)   
#define DOT3_ON()                  (LCD->MEM_2 |=  0x00010000)   
#define DOT3_OFF()                 (LCD->MEM_2 &= ~0x00010000)   
#define DOT2_ON()                  (LCD->MEM_3 |=  0x00000001)   
#define DOT2_OFF()                 (LCD->MEM_3 &= ~0x00000001)   
#define COOL_ON()                  (LCD->MEM_3 |=  0x00010000)   
#define COOL_OFF()                 (LCD->MEM_3 &= ~0x00010000)   

// ⼸ͼ궼 LCD->MEM_4
#define ICON_FLOW                  (0x00000001)   
#define ICON_LIANG                 (0x00000002)   
#define ICON_ENTER                 (0x00000004)   
#define ICON_BACK                  (0x00000008)   
#define ICON_k                     (0x00000100)   
#define ICON_h                     (0x00000200)   
#define ICON_m3                    (0x00000400)   
#define ICON_c                     (0x00000800)   
#define ICON_GJ                    (0x00010000)   
#define ICON_M                     (0x00020000)   
#define ICON_Wh                    (0x00040000)   
#define ICON_L                     (0x00080000)  

#define ICON_BATTER                (0x02000000)   
#define ICON_ERR                   (0x04000000)   
#define ICON_Delt_T                (0x08000000)   
#endif     //__IP_INIT_H
