////=====================================================================================
//// ú, ļ
////=====================================================================================
#define  IP_INIT_GLOBAL
#include "Nano1X2Series.h"
#include "IP_Init.h"

//// ʱú ///////////////////////////////////////////////////////////////////////
void SysClkInit(void)
{
  SYS_UnlockReg() ;                                        // ֻ HIRC=12M 
  CLK->PWRCTL  = CLK_PWRCTL_DELY_EN | CLK_PWRCTL_HIRC_EN ;         
  CLK->CLKDIV0 = CLK_HCLK_CLK_DIVIDER(1) ;                 // HCLK = 12M  
  CLK->CLKDIV1 = CLK_TMR1_CLK_DIVIDER(12) ;                // Timer1 12Ƶ 1M   
  
  CLK->CLKSEL1 = CLK_CLKSEL1_TMR1_S_HCLK                   // ʱѡ
               | CLK_CLKSEL1_UART_S_HIRC 
               | CLK_CLKSEL1_ADC_S_HCLK ; 
                                                           // ʱʹ
  CLK->AHBCLK  = CLK_AHBCLK_SRAM_EN 
               | CLK_AHBCLK_ISP_EN 
               | CLK_AHBCLK_GPIO_EN ;
  CLK->APBCLK  = CLK_APBCLK_TMR1_EN 
               | CLK_APBCLK_TMR0_EN 
               | CLK_APBCLK_I2C1_EN 
               | CLK_APBCLK_ADC_EN
               | CLK_APBCLK_UART1_EN
               | CLK_APBCLK_UART0_EN ;
  SYS_LockReg() ;                                              
}                        
void Delayus(uint32_t Tim)                                
{
  uint32_t Tick = TIMER1->DR ;
  while(((TIMER1->DR - Tick)&0xFFFFFF) <= Tim) ;
}
//// Timer1, 1MHz ,  // 24λ,  16.77, ͨöʱ ////////////////////////
void Timer1Init(void) 
{
  TIMER1->CTL    = TIMER_CONTINUOUS_MODE | TIMER_CTL_TMR_EN_Msk ; 
  TIMER1->CMPR   = 100000 ;
  TIMER1->PRECNT = 0 ;                                                      
  TIMER1->IER    = TIMER_IER_TMR_IE_Msk ;                                 
  NVIC_SetPriority(TMR1_IRQn, 2) ;  
  NVIC->ISER[0]  = 1 << TMR1_IRQn ;
}
void UART0_Init(uint32_t Baud)
{
  UART0->FUN_SEL = UART_FUNC_SEL_UART ;                                        
  UART0->TLCTL   = 0x3303 ;                      // 8bit 1-stop no parity RTS:14,RxFiFo:14   
  UART0->BAUD    = 12000000/Baud -1 ;                       
  UART0->TMCTL   = 0x000000FF ;                  //Max reception interval 256bit
  UART0->IER     = UART_IER_RTO_IE_Msk | UART_IER_RDA_IE_Msk ; 
  NVIC_SetPriority(UART0_IRQn, 2) ;  
  NVIC->ISER[0]  = 1 << UART0_IRQn ;
}
void UART1_Init(uint32_t Baud)                   // WiFi ͸
{
  UART1->FUN_SEL = UART_FUNC_SEL_UART ;                                      
  UART1->TLCTL   = 0x3303 ;                      //8bit 1-stop no parity RTS:14,RxFiFo:14   
  UART1->BAUD    = 12000000/Baud -1 ;       
  UART1->TMCTL   = 0x000000FF ;                  //Max reception interval 256bit
  UART1->IER     = UART_IER_RTO_IE_Msk | UART_IER_RDA_IE_Msk ; 
  NVIC_SetPriority(UART1_IRQn, 2) ;  
  NVIC->ISER[0]  = 1 << UART1_IRQn ;
}
void I2C1_Init(uint8_t Address)
{
  I2C1->CON     = I2C_CON_INTEN_Msk
                | I2C_CON_IPEN_Msk ;
  I2C1->SADDR0  = Address ;
  I2C1->DIV     = 12000/4/100 - 1 ;                        // 100K  
  
  NVIC_SetPriority(I2C1_IRQn, 2) ;                         // жȼ 2
  NVIC_EnableIRQ(I2C1_IRQn) ;	                             // ʹж
}
void RTC_Init(void)
{
  RTC->INIR = 0xA5EB1357 ;                                 // ˳λ, 
  RTC->AER  = 0xA965 ;                                     // дFCR,TAR,CARͱRAM
  while((RTC->AER & RTC_AER_ENF_Msk)==0);
  RTC->TLR  = 0x120000 ;                                   // 12:00:00
  RTC->CLR  = 0x150501 ;                                   // 2015/05/01
  RTC->TSSR = 1 ;                                          // 24Сʱ
  RTC->DWR  = 5 ;                                          // 
  RTC->RIER = 2 ;                                          // ʹ Tick ж
  RTC->TTR  = 0x08 ;                                       // Tick һӻһ  
  NVIC_SetPriority(RTC_IRQn, 2);
  NVIC->ISER[0] = 1ul<<RTC_IRQn ;		
  Delayus(70) ;
}
/////////////////////////////////////////////////////////////////////////////////////////
void SPI1_Init(uint32_t Div)
{
  SPI1->CLKDIV = Div - 1 ;                                 // coefficient of devide frequency
  SPI1->CTL    = SPI_CTL_FIFOM_Msk                         // Enable FiFo
               | SPI_CTL_RX_NEG_Msk ;                      // Receiving at falling edge
  SPI_SET_SUSPEND_CYCLE(SPI1, 1) ;                         // suspend 1 SPI_CLK every transfer
  SPI_SET_DATA_WIDTH(SPI1, 8) ;                            // 8 bit every transfer
}
void LCD_Init(void)                              // 8ִMEM0,MEM1,MEM2,MEM3 
{               
  LCD->CTL     = LCD_FREQ_DIV96                           // LCDʱ341*4Ƶ=85Hz
               | LCD_MUX_ONE_FOURTH                        // 4-MUX
               | LCD_CTL_PDDISP_EN_Msk                     // ״̬, LCD ʾ
               | LCD_CTL_EN_Msk  ;                         // LCD ʹ

	LCD->DISPCTL = LCD_DISPCTL_Res_Sel_Msk                   // ڲ400K                    
               | LCD_DISPCTL_BV_SEL_Msk                    // R-Type
               | LCD_DISPCTL_IBRL_EN_Msk                   // ʹ
               | LCD_BIAS_THIRD ;                          // 1/3ƫѹ
}
void ADC_Init(void)
{
  ADC->CR   = ADC_RESSEL_12_BIT | ADC_OPERATION_MODE_SINGLE_CYCLE | ADC_CR_ADEN_Msk ;
  ADC->CHEN = 0x0030 ;   
}
