////=====================================================================================
//// жϺ, ļ
////=====================================================================================
#include "Nano1X2Series.h"
#include "IP_Init.h"

void TMR1_IRQHandler(void)
{
  uint32_t static CntInt = 0 ;
  
  Event |= Event_T1_INT ;   
  if(++CntInt >= 5){ CntInt=0;  Event |= Event_T1_INT_5; }
  TIMER1->CMPR += 100000 ;  
  TIMER1->ISR  = ~0 ;                                    
}

void RTC_IRQHandler(void)
{
  RTC->RIIR = ~0 ;
   
}
void UART0_IRQHandler(void)                                // MBUS
{
  uint32_t temp32 ;
  
  while(!(UART0->FSR & UART_FSR_RX_EMPTY_F_Msk)){
    temp32 = UART0->RBR ;
    if(COM0_Data.NumRx){  --COM0_Data.NumRx ;
      *COM0_Data.pRx++ = temp32 ;
    }
  }
  Event |= Event_UART0_Rx ;  
  UART0->ISR = ~0 ;                                        // һ32768ʱӺ0
}
void UART1_IRQHandler(void)                                // IrDA
{
  uint32_t temp32 ;

  while(!(UART1->FSR & UART_FSR_RX_EMPTY_F_Msk)){
    temp32 = UART1->RBR ;                                  // յ
    if(COM1_Data.NumRx){  --COM1_Data.NumRx ;
      *COM1_Data.pRx++ = temp32 ;
    }
    if(temp32 & 1) LED_R_ON();
    else LED_R_OFF();
    if(temp32 & 2) LED_G_ON();
    else LED_G_OFF();
    if(temp32 & 4) LED_B_ON();
    else LED_B_OFF();
    if(temp32 & 0x10) BUZZER_ON();
    else BUZZER_OFF();
  }
  Event |= Event_UART1_Rx ;                                // ֪ͨж⴦                      
  UART1->ISR = ~0 ;                                        // жϱ־
}
void I2C1_IRQHandler(void)
{
  uint32_t Status = I2C1->STATUS ;							           // ȶ״ֽ̬

  switch(Status){
  //// ״̬: 꿪ʼ08,ַյACK_18,յACK_28 ///////////////////////  
  case  0x08 :                                             // Start   
    I2C1->CON &= ~I2C_CON_START_Msk ;                      // NanoԶ0, M4
    I2C1->CON |=  I2C_CON_ACK_Msk ;
  case  0x18 :                                             // 豸ַ,յACK
  case  0x28 :                                             // ,յACK
    if(I2C_Buf.NumTx){
      --I2C_Buf.NumTx ;
      I2C1->DATA = *I2C_Buf.pTx++ ;                         // һ
    }
    else I2C1->CON |= I2C_CON_STOP_Msk ;                    //  STOP, λӲԶ0
    break ; 
  
  //// ״̬: 꿪ʼ08,ַյACK_40, ݷACK_50ACK_58 ////////////  
  case 	0x50 :											                       // յݲACK                               
    *I2C_Buf.pRx++ = I2C1->DATA ;
    if(I2C_Buf.NumRx) --I2C_Buf.NumRx ;
  case  0x40 :                                             // 豸ַ,յACK
    if(I2C_Buf.NumRx <= 1) I2C1->CON &= ~I2C_CON_ACK_Msk;	 // һ״̬Ϊ0x58
	  break ;
  
  case  0x58 :                                             // һ
    *I2C_Buf.pRx = I2C1->DATA ;
    --I2C_Buf.NumRx ;
  
  //// ,ʧȥٲ //////////////////////////////////////////////////////////////    
  case  0x20 :                                             // 豸ַ, ûյACK
  case  0x30 :                                             // ,ûյACK
    if(I2C_Buf.NumTx){  
      gFlag |= F_I2C_ERR ;
      I2C_Buf.NumTx = 0 ;
    }
  default    :    
    I2C1->CON |= I2C_CON_STOP_Msk ;                        //  STOP, λӲԶ0
  }
 
  //// ʼһ ///////////////////////////////////////////////////////////////////////
  I2C1->INTSTS |= I2C_INTSTS_INTSTS_Msk ;
  I2C1->CON    |= I2C_CON_I2C_STS_Msk ;
}
