//=================================================================================================
// Copyright (C) 2015 Nuvoton(SH) Technology Corp. All rights reserved 
//=================================================================================================
#include "Nano1X2Series.h"
#include "IP_Init.h"

#define  GAS_SENSOR_HEAT_ON()      (PD->DOUT |=  0x1000)  
#define  GAS_SENSOR_HEAT_OFF()     (PD->DOUT &= ~0x1000) 

#define  DH11_PUSH_LOW()           (PD11 = 0)
#define  DH11_KEEP_HIGH()          (PD11 = 1)
#define  DH11_READ_PIN()           (PD11)

uint8_t GyroSet0[] ={
    0xD0,                                                  // 0xD0дMPU6050, 0xD1,
    0x19,                                                  // ַ 0x19ʼ,
    9,                                                     //  1K/10 = 100
    2,                                                     // A 94Hz, G 98Hz
    0,                                                     // 250/S
    0,                                                     // 2g
};
uint8_t GyroSet1[] ={
    0xD0,
    0x6B,                                                  // 107
    1
};
// 59/60_Ax,  61/62_Ay, 63/64_Az,  65/66_temperature
// 67/68_Gx,  69/70_Gy, 71/72_Gz,
uint8_t  Temperature[7] = {'\n',0x23,0,0,0,0,0} ;          // #
uint8_t  Fuel[4]        = {'\n',0x24,0,0} ;                // $
uint8_t  GyroData[16]   = {'\n',0x25,0,0,0,0,0,0, 0,0, 0,0,0,0,0,0} ;

/// PA~PE16GPIO, ûĽҲҪ벢 ///////////////////////////////
void GpioInit(void)                                        
{  
  // PA 5GPIO, PA4/5/12/13/14, PA14_LED_G
  PA->DOUT      = 0xFFFF ;  
  PA->PMD       = 0x20000000 ;                             // PA14 OD 1
  PA->PUEN      = 0 ;                                      // 1ʹ
  PA->OFFD      = 0x00300000;                              // PA45  
  SYS->PA_H_MFP = SYS_PA_H_MFP_PA13_MFP_UART0_RX 
                | SYS_PA_H_MFP_PA12_MFP_UART0_TX ;                
  SYS->PA_L_MFP = SYS_PA_L_MFP_PA5_MFP_ADC_CH5             // fuel
                | SYS_PA_L_MFP_PA4_MFP_ADC_CH4 ;           // Light
  
  // PB 4GPIO, PB12~15,  PB15_LED_R
  PB->DOUT      = 0xFFFF ;  
  PB->PMD       = 0x80000000 ;                             // PB15 OD 1
  PB->PUEN      = 0x7000 ;                                
  SYS->PB_L_MFP = 0 ; 
  SYS->PB_H_MFP = 0 ;                            
  
  // PC 8GPIO, PC4/6/7/8/10~13, PC13_6050INT
  PC->DOUT      = 0xFFFF ;  
  PC->PMD       = 0x01001100 ;                                    
  PC->PUEN      = 0x0200 ;                                 // PC13 ʹ
  SYS->PC_L_MFP = SYS_PC_L_MFP_PC7_MFP_UART1_RX;                             
  SYS->PC_H_MFP = SYS_PC_H_MFP_PC8_MFP_UART1_TX
                | SYS_PC_H_MFP_PC10_MFP_I2C1_SCL 
                | SYS_PC_H_MFP_PC11_MFP_I2C1_SDA ;                       
  
  // PD 4GPIO,  PD9~12,   PD11_QB
  PD->DOUT      = 0xFFFF ;  
  PD->PMD       = 0x01940000 ;
  PD->PUEN      = 0x0800;
  SYS->PD_L_MFP = 0 ;
  SYS->PD_H_MFP = 0 ;
  
  // 64PIN װ PE û, ҲҪ ///////////////////////////////////////
  PE->DOUT      = 0xFFFF ;  
  PE->PMD       = 0 ;                                                    
  PE->PUEN      = 0xFFFF ;
  SYS->PE_L_MFP = 0 ;                        
  SYS->PE_H_MFP = 0 ;
  
  // PF0123.  4GPIO  
  PF->DOUT      = 0xFFFF ;  
  PF->PMD       = 0 ;
  PF->PUEN      = 0xFFFF ;                               
  PF->OFFD      = 0x000F0000 ;                           
  SYS->PF_L_MFP = 0  ; 
}
////// SPI1 շ, ж,  //////////////////////////////////////////////
//// : pTr,  ͵ַ 
////       Num,  ȫ˫շַ
////       pRx,  ַŵַ
//void SPI1_TxRx(uint8_t *pTx, uint32_t Num, uint8_t *pRx )
//{
//  uint32_t Cnt = 6, CntRx = Num ;
//  
//  PA->DOUT &= ~0x8000 ;                                    // SS = 0 ;
//  while(Num){ --Num ;
//    SPI1->TX1 = *pTx++ ;       
//    if(--Cnt == 0) break ;
//  }
//  
//  while(CntRx){ --CntRx; 
//    while(SPI1->STATUS & SPI_STATUS_RX_EMPTY_Msk) ;
//    *pRx++ = SPI1->RX1 ;       
//    if(Num){ --Num; SPI1->TX1 = *pTx++; }      
//  }
//  PA->DOUT |= 0x8000 ;                                     // SS = 1 ;
//}
uint8_t Str[64] = "001234567890" ;
uint32_t ReadLine(uint8_t *Err)
{
  uint32_t Tick, T0 = ~0 ;
  
  Tick = TIMER1->DR ;
  do{
    if(DH11_READ_PIN() == 1) {T0 = TIMER1->DR; break; }
  }while(((TIMER1->DR - Tick) & 0xFFFFFF) < 300);
  if(T0 == (~0)) { *Err = 1; return 0; }
  
  do{
    if(DH11_READ_PIN() == 0) {
      if(((TIMER1->DR - T0)&0xFFFFFF) < 40) return 0 ; 
      else return 1 ;
    }
  }while(((TIMER1->DR - T0)&0xFFFFFF) < 300);
  *Err = 1 ;
  return 0 ;
}
void GetTemp(void)
{
  uint8_t Err = 0, Data, Cnt = 0, Check ;
  
  DH11_PUSH_LOW(); Delayus(20000);  DH11_KEEP_HIGH();      // Start
  Delayus(190);                                            // First 50us Low
  Cnt = 8;
  do{
    Data <<= 1 ;
    Data |= ReadLine(&Err) ;
  }while(--Cnt);
  Temperature[2] = Data ; Check = Data ;
  
  Cnt = 8;
  do{
    Data <<= 1 ;
    Data |= ReadLine(&Err) ;
  }while(--Cnt);
  Temperature[3] = Data ; Check += Data ;
  
  Cnt = 8;
  do{
    Data <<= 1 ;
    Data |= ReadLine(&Err) ;
  }while(--Cnt);
  Temperature[4] = Data ; Check += Data ;
  
  Cnt = 8;
  do{
    Data <<= 1 ;
    Data |= ReadLine(&Err) ;
  }while(--Cnt);
  Temperature[5] = Data ; Check += Data ;
  
  Cnt = 8;
  do{
    Data <<= 1 ;
    Data |= ReadLine(&Err) ;
  }while(--Cnt);
  if((Data == Check) && (Err == 0))Temperature[6] = 1 ; 
  else  Temperature[6] = 0 ; 
}
/////////////////////////////////////////////////////////////////////////////////////////
int32_t main(void)							   
{   
  uint8_t *pStr, temp16 ;
  
  SysClkInit() ;           
  ADC_Init() ;  
  Timer1Init() ;                                           // Delayus()ʱ Timer1
  I2C1_Init(0) ; 
                    // GPIOйص÷Ŵ
  GpioInit() ;                                             // GPIO 
  UART1_Init(115200) ;                                     // WiFi ͸
  UART1->THR = '\n'; UART1->THR = 'O';UART1->THR = 'K';  
  
  BUZZER_OFF() ;
  GAS_SENSOR_HEAT_OFF() ; 
  
  do{
    gFlag &= ~F_I2C_ERR ;
    
    I2C_Buf.pTx   = GyroSet0 ;                               // ַ
    I2C_Buf.NumTx = 6 ;                                      // ݸ(豸ַ)  
    I2C1->CON    |= I2C_CON_START_Msk ;
    while(I2C_Buf.NumTx);                                    // һݸտʼ
    Delayus(200) ;                                           // 100K, Լ110usһ 
     
    I2C_Buf.pTx   = GyroSet1 ;                               // ַ
    I2C_Buf.NumTx = 3 ;                                      // ݸ(豸ַ)  
    I2C1->CON    |= I2C_CON_START_Msk ;
    while(I2C_Buf.NumTx);                                    // һݸտʼ
    Delayus(200) ;                
  }while(gFlag & F_I2C_ERR) ;   
  ///////////////////////////////////////////////////////////////////////////////////////

  Event = 0 ;   
	while(1){
    while(Event == 0){                                     // ¿, 
			SYS_UnlockReg() ;
			  CLK->PWRCTL |= CLK_PWRCTL_PWRDOWN_EN ;             // ߹ʹλ,Զ 
//        SCB->SCR    |= 0x04 ;                              // ģʽ
			SYS_LockReg() ;      
			__wfi() ;                                            // л״̬      
    } 
    /////////////////////////////////////////////////////////////////////////////////////
    if(Event & Event_T1_INT){ Event &= ~Event_T1_INT ;    
      ADC->CR  |= ADC_CR_ADST_Msk ;                        //  ADC
    }
    
    if(Event & Event_T1_INT_5){  Event &= ~Event_T1_INT_5 ;       
      LED_R_TOGGLE() ;  
      temp16 = ADC->RESULT[5] ;
      Fuel[2] = temp16 >> 8 ; Fuel[3] = temp16 ;
      pStr = Fuel ;     UART1->THR = *pStr++ ;
      UART1->THR = *pStr++ ;  UART1->THR = *pStr++ ; UART1->THR = *pStr++ ;
    }
    /////////////////////////////////////////////////////////////////////////////////////
  }
}
